// Specify in VC++ Project Settings!!
//#define USE_MUSIC
//#define USE_SOUND

#define _WIN32_WINDOWS 0x0410
#include <windows.h>
#include <math.h>
#ifdef USE_SOUND
#include "wavemix/wavemix.h"
#endif
#if defined USE_MUSIC || defined USE_SOUND
#include "minifmod/minifmod.h"
#endif
#ifdef USE_MUSIC
#include "mfcallbk.h"
#endif
#include "resource.h"

#include "stdio.h"
#include "main.h"

typedef struct{
	WORD	major;
	WORD	minor;
	WORD	patch;
	WORD	build;
}version;

version getVersion()
{
	char name[MAX_PATH + 1];
	char* vi;
	DWORD size;
	version v = {0, 0, 0, 0};

	GetModuleFileName(NULL, name, MAX_PATH);
	size = GetFileVersionInfoSize(name, 0);
	if(!(vi = malloc(size)))
		return v;

	GetFileVersionInfo(name, 0, size, vi);
	{
		VS_FIXEDFILEINFO* ver = (VS_FIXEDFILEINFO*)(vi + 40);

		// nameg
		v.major = HIWORD(ver->dwFileVersionMS);
		v.minor = LOWORD(ver->dwFileVersionMS);
		v.patch = HIWORD(ver->dwFileVersionLS);
		v.build = LOWORD(ver->dwFileVersionLS);
	}

	free(vi);

	return v;
}




#ifdef USE_MUSIC
void changeBGM(DWORD res)
{
	DWORD i;

	if(res == 0xFFFF)
	{
		FMUSIC_StopSong(mods[nowbgm]);
		nowbgm = 0xFFFF;
		if(bgmphase == BGMPHASE_FADEIN)
		{
			bgmphase = BGMPHASE_FADEOUT;
			bgmtitlecount = BGMTC_FADE_TIME - bgmtitlecount;
		}
		if(bgmphase == BGMPHASE_SHOWING)
		{
			bgmphase = BGMPHASE_FADEOUT;
			bgmtitlecount = BGMTC_FADE_TIME;
		}
		return;
	}

	for(i = 0; i < sizeof(bgms) / sizeof(DWORD); i++)
	{
		if(bgms[i] == res)
			break;
	}

	if(nowbgm == i)
		return;	// ςȂ

	// ȂONĎSˁB

	nowbgm = i;
	mod = mods[i];
	FMUSIC_PlaySong(mod);

	bgmphase = BGMPHASE_FADEIN;
	bgmtitlecount = BGMTC_FADE_TIME;

	return;
}

BOOL cacheBGM(void)
{
	DWORD i;

	for(i = 0; i < sizeof(bgms) / sizeof(DWORD); i++)
		if(!(mods[i] = FMUSIC_LoadSong(MAKEINTRESOURCE(bgms[i]), NULL)))
			return TRUE;

	return FALSE;
}
void uncacheBGM(void)
{
	DWORD i;

	for(i = 0; i < sizeof(bgms) / sizeof(DWORD); i++)
		FMUSIC_FreeSong(mods[i]);

	return;
}

#endif






HPEN SelectPen(HDC hdc, int fnPenStyle, int nWidth, COLORREF crColor)
{
	HPEN newpen, oldpen;

	if(!(newpen = CreatePen(fnPenStyle, nWidth, crColor)))
		return NULL;
	oldpen = SelectObject(hdc, newpen);

	return oldpen;
}

HBRUSH SelectSolidBrush(HDC hdc, COLORREF crColor)
{
	HBRUSH newbrush, oldbrush;

	newbrush = CreateSolidBrush(crColor);
	oldbrush = SelectObject(hdc, newbrush);

	return oldbrush;
}

HBITMAP SelectDIBSection(
    HDC hdc,
    CONST BITMAPINFO *pbmi,
    UINT iUsage,
    VOID *ppvBits,
    HANDLE hSection,
    DWORD dwOffset
)
{
	HBITMAP newbmp, oldbmp;

	if(!(newbmp = CreateDIBSection(hdc, pbmi, iUsage, ppvBits, hSection, dwOffset)))
		return NULL;
	oldbmp = SelectObject(hdc, newbmp);

	return oldbmp;
}

HFONT SelectFont(HDC hdc, LPCSTR fontname, int size, int style)
{
	HFONT newfont, oldfont;
	LOGFONT lf = {0};

	lf.lfCharSet = DEFAULT_CHARSET;
	lf.lfHeight = size;
	strcpy(lf.lfFaceName, fontname);

	if(!(newfont = CreateFontIndirect(&lf)))
		return NULL;
	oldfont = SelectObject(hdc, newfont);

	return oldfont;
}

BOOL RestoreObject(HDC hdc, HGDIOBJ oldobj)
{
	return DeleteObject(SelectObject(hdc, oldobj));
}

BOOL FillRectangle(HDC hdc, int sx, int sy, int ex, int ey, HBRUSH hbr)
{
	RECT rc = {sx, sy, ex, ey};

	return FillRect(hdc, &rc, hbr);
}

BOOL FillRectangleColor(HDC hdc, int sx, int sy, int ex, int ey, COLORREF crColor)
{
	RECT rc = {sx, sy, ex, ey};
	HBRUSH hbr = CreateSolidBrush(crColor);
	BOOL result;

	result = FillRect(hdc, &rc, hbr);

	DeleteObject(hbr);

	return result;
}

float rnd(int max)
{
	return ((float)rand() / RAND_MAX) * max;
}

float pmrnd(float max)
{
	return ((float)rand() / RAND_MAX) * max - max / 2;
}

void addData(void* data, DWORD size)
{
	if(replaydata.length + size >= replaydata.alloced)
	{
		replaydata.alloced += REPLAYBUFFERSIZE;
		if(!(replaydata.data = realloc(replaydata.data, replaydata.alloced)))
			MessageBox(hMainWnd, "realloc failed", "Error", MB_ICONERROR | MB_OK);
	}
	memcpy(replaydata.data + replaydata.length, data, size);
	replaydata.length += size;

	return;
}

void record(DWORD type, void* data, DWORD size)
{
	if(!recordreplay)	// If not record, go back!!
		return;

	addData(&type, 4);
	addData(&size, 4);
	addData(data, size);

	return;
}

int makeRock(float x, float y, float px, float py, int size)
{
	int i;

	for(i = 0; i < MAXROCKS; i++)
		if(!rock[i].visible)
			break;

	if(i == MAXROCKS)	// No More Space!
		return 1;

	if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
	{
		int j;

		for(j = 0; j < i; j++)
			if(square(rock[j].x - x) + square(rock[j].y - y) <= square(rock[j].size + size))
				break;
		if(j < i)
			return 1;
	}

	rock[i].visible = 1;
	rock[i].x = x;
	rock[i].y = y;
	rock[i].px = px;
	rock[i].py = py;
	rock[i].size = size;
	rock[i].rotate = rnd(360);
	rock[i].rotaterate = (rnd(3) - 1) / 10;
	rock[i].cubecounted = FALSE;
	{
		int j;

		for(j = 0; j < ROCKDIVIDE; j++)
			rock[i].vertex[j] = (int)rnd(rock[i].size / 2) - rock[i].size / 4;
	}

	if(gamestatus == GAMESTAT_PLAYING)
		record(RECORD_MAKEROCK, &rock[i], sizeof(rock[i]));

	return 0;
}

void drawRock()
{
	int i;

	for(i = 0; i < MAXROCKS; i++)
		if(rock[i].visible)
		{
			int j;

			for(j = 0; j < ROCKDIVIDE; j++)
			{
				int k = (j + 1 == ROCKDIVIDE) ? 0 : j + 1;
				double deg = (double)j * (360.0 / ROCKDIVIDE) * (PI/180) + rock[i].rotate;
				double degplus = (double)(k) * (360.0 / ROCKDIVIDE) * (PI/180) + rock[i].rotate;

				MoveToEx(hBackBuffer,
					(int)(rock[i].x + (cos(deg) * (rock[i].size + rock[i].vertex[j]))),
					(int)(rock[i].y + (sin(deg) * (rock[i].size + rock[i].vertex[j]))),
					NULL);
				LineTo(hBackBuffer,
					(int)(rock[i].x + (cos(degplus) * (rock[i].size + rock[i].vertex[k]))),
					(int)(rock[i].y + (sin(degplus) * (rock[i].size + rock[i].vertex[k])))
					);
			}
		}

	return;
}

int sgn(float val)
{
	if(val < 0)
		return -1;
	if(val > 0)
		return 1;
	return 0;
}

double getRadian(double x, double y)
{
	if(x == 0)
	{
		if(y == 0)
			return 0;
		else
			if(0 < y)
				return PI / 2;
			else
				return PI * 3 / 2;
	}else
	{
		double rad;

		rad = atan(y / x);

		if(x < 0)
			rad = PI + rad;
		else
			if(y < 0)
				rad = 2 * PI + rad;	// rad is minus.

		return rad;
	}
}

void moveRock()
{
	int i;
	int leftline = 0;

	if((gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3) && gamestatus == GAMESTAT_PLAYING)
		leftline = avoided * 2;

	for(i = 0; i < MAXROCKS; i++)
		if(rock[i].visible)
		{
			// MoveTest
			if((gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3) && (gamestatus == GAMESTAT_TITLE || gamestatus == GAMESTAT_PLAYING))
			{
				int j;

				if(rock[i].x < leftline)
					continue;

				for(j = 0; j < MAXROCKS; j++)
				{
					if(i == j || !rock[j].visible)
						continue;
					if(rock[i].x < rock[j].x)
						continue;
					if(square(rock[i].x - rock[j].x) + square(rock[i].y - rock[j].y) <= square(rock[i].size + rock[j].size))
						break;
				}
				if(j < MAXROCKS)
					continue;
			}

			rock[i].x += rock[i].px;
			rock[i].y += rock[i].py;
			rock[i].rotate += rock[i].rotaterate;

			if(gamestatus == GAMESTAT_PLAYING)
			{	// TraceMyship!!
				if(gametype == GAMETYPE_CUBERUSH)
				{
					float rate = 0.2f;

					if(myship.y - 80 < rock[i].y && rock[i].y < myship.y + 80)
					{
						rate = 0.4f;
						if(myship.y - 60 < rock[i].y && rock[i].y < myship.y + 60)
						{
							rate = 0.6f;
							if(myship.y - 40 < rock[i].y && rock[i].y < myship.y + 40)
							{
								rate = 0.8f;
								if(myship.y - 20 < rock[i].y && rock[i].y < myship.y + 20)
								{
									rate = 1;
									if(myship.y - 10 < rock[i].y && rock[i].y < myship.y + 10)
									{
										rate = 2;
									}
								}
							}
						}
					}
					rock[i].py += (float)(sgn(myship.y - rock[i].y) * rate);
				}
				if(gametype == GAMETYPE_CUBERUSH2)
				{
					if((i % 3 == 0 || i % 5 == 0) && rock[i].x < FIELDX / 2 && rock[i].py == 0)
					{
						// oops...
						//rock[i].py = (myship.y - rock[i].y) / ((myship.x - rock[i].x) / rock[i].px);
						double r = getRadian((myship.x - rock[i].x), myship.y - rock[i].y);
						rock[i].py = (float)(sin(r) * -rock[i].px*1.5f);
						rock[i].px = (float)(cos(r) * -rock[i].px*1.5f);
					}
				}
			}
		}

	return;
}

void initGUI(void)
{
	DWORD i;

	for(i = 0; i < sizeof(gui) / sizeof(struct _tag_gui); i++)
		if(gui[i].init)
			gui[i].init(&gui[i]);
}

void freeGUI(void)
{
	DWORD i;

	for(i = 0; i < sizeof(gui) / sizeof(struct _tag_gui); i++)
		if(gui[i].free)
			gui[i].free(&gui[i]);
}

void setGameStatus(DWORD status)
{
	if(gamestatus != GAMESTAT_DIPSWITCH && status == GAMESTAT_DIPSWITCH)	// ? -> DipSwitch
		initGUI();

	if(gamestatus == GAMESTAT_DIPSWITCH && status != GAMESTAT_DIPSWITCH)	// DipSwitch -> ?
		freeGUI();

	gamestatus = status;
	elapsed = 0;
	cubethrowed = 0;
	cubecount = 0;

	if(status == GAMESTAT_TITLE)
	{
		level = 0;
		life = config.power;
		avoided = 0;
	}

	return;
}

void hitTest()
{
	int i;
	int leftline = 0;

	if((gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3) && gamestatus == GAMESTAT_PLAYING)
		leftline = avoided * 2;

	for(i = 0; i < MAXROCKS; i++)
		if(rock[i].visible)
		{
			int size = rock[i].size*3;

			if((gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3) && cubethrowed && !rock[i].cubecounted)
			{
				int j;

				if(rock[i].x < leftline)
				{
#ifdef USE_SOUND
					if(gamestatus == GAMESTAT_TITLE || gamestatus == GAMESTAT_PLAYING)
						//PlaySound(MAKEINTRESOURCE(IDR_CUBE), hInst, SND_RESOURCE | SND_ASYNC);
						wmPlayWave(wavCube);
#endif
					rock[i].cubecounted = TRUE;
					cubethrowed--;
					avoided++;
				}else
				{
					for(j = 0; j < MAXROCKS; j++)
					{
						if(i == j || !rock[j].visible)
							continue;
						if(rock[i].x < rock[j].x)
							continue;
						if(square(rock[i].x - rock[j].x) + square(rock[i].y - rock[j].y) <= square(rock[i].size + rock[j].size))
							break;
					}
					if(j < MAXROCKS)
					{
#ifdef USE_SOUND
						if(gamestatus == GAMESTAT_TITLE || gamestatus == GAMESTAT_PLAYING)
							//PlaySound(MAKEINTRESOURCE(IDR_CUBE), hInst, SND_RESOURCE | SND_ASYNC);
							wmPlayWave(wavCube);
#endif
						rock[i].cubecounted = TRUE;
						cubethrowed--;
						avoided++;
					}
				}
			}

			// ؂蔻
			if(rock[i].x < -size)	// if left
			{
				rock[i].visible = FALSE;	// DIE!
				if(diecount != -1)
				{
					if(gametype == GAMETYPE_NORMAL && gamestatus == GAMESTAT_PLAYING)
						score++;
					avoided++;
				}
				if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
					cubethrowed--;
			}
			if(rock[i].y < -size)	// if top
			{
				rock[i].visible = FALSE;	// DIE!
				if(diecount != -1)
				{
					if(gametype == GAMETYPE_NORMAL && gamestatus == GAMESTAT_PLAYING)
						score++;
					avoided++;
				}
				if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
					cubethrowed--;
			}
			if(FIELDX + size < rock[i].x )	// if right
			{
				rock[i].visible = FALSE;	// DIE!
				if(diecount != -1)
				{
					if(gametype == GAMETYPE_NORMAL && gamestatus == GAMESTAT_PLAYING)
						score++;
					avoided++;
				}
				if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
					cubethrowed--;
			}
			if(FIELDY + size < rock[i].y )	// if bottom
			{
				rock[i].visible = FALSE;	// DIE!
				if(diecount != -1)
				{
					if(gametype == GAMETYPE_NORMAL && gamestatus == GAMESTAT_PLAYING)
						score++;
					avoided++;
				}
				if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
					cubethrowed--;
			}

			// ʂȔh~
#ifdef _DEBUG
			if(!(GetAsyncKeyState(VK_SHIFT) & 0x80000000))	// Shift͖G@debug
#endif
			if(gamestatus == GAMESTAT_PLAYING)
			{
				// S
				if(square(rock[i].x - myship.x) + 
					square(rock[i].y - myship.y) <=
					square(rock[i].size + 4) && !diecount)
				{
					if(gametype == GAMETYPE_NORMAL)
					{
						life--;
						if(life == 0)
						{
							diecount = -1;
#ifdef USE_SOUND
							//PlaySound(MAKEINTRESOURCE(IDR_OVER), hInst, SND_RESOURCE | SND_ASYNC);
							wmPlayWave(wavOver);
#endif
							setGameStatus(GAMESTAT_DEAD);
						}else
						{
							diecount = config.recovertime;
#ifdef USE_SOUND
							//PlaySound(MAKEINTRESOURCE(IDR_HIT), hInst, SND_RESOURCE | SND_ASYNC);
							wmPlayWave(wavHit);
#endif
						}
					}
					if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
					{
						life = 0;
						diecount = -1;
#ifdef USE_SOUND
						//PlaySound(MAKEINTRESOURCE(IDR_GRABOOM), hInst, SND_RESOURCE | SND_ASYNC);
						wmPlayWave(wavGraboom);
#endif
						setGameStatus(GAMESTAT_DEAD);
					}
				}

				// 肬蔻
				if(gametype == GAMETYPE_NORMAL)
					if((rock[i].x - myship.x)*(rock[i].x - myship.x) + 
						(rock[i].y - myship.y)*(rock[i].y - myship.y) <=
						(rock[i].size * 1.3 + 4)*(rock[i].size * 1.3 + 4) && !diecount)
					{
						score++;
#ifdef USE_SOUND
						//PlaySound(MAKEINTRESOURCE(IDR_SCR), hInst, SND_RESOURCE | SND_ASYNC);
						wmPlayWave(wavScr);
#endif
					}
			}
		}

	if((gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3) && gamestatus == GAMESTAT_PLAYING && myship.x < (int)avoided * 2)
	{
		life = 0;
		diecount = -1;
#ifdef USE_SOUND
		//PlaySound(MAKEINTRESOURCE(IDR_GRABOOM), hInst, SND_RESOURCE | SND_ASYNC);
		wmPlayWave(wavGraboom);
#endif
		setGameStatus(GAMESTAT_DEAD);
	}

	return;
}

void line(HDC hdc, int sx, int sy, int ex, int ey)
{
	POINT old;

	MoveToEx(hdc, sx, sy, &old);
	LineTo(hdc, ex, ey);
	MoveToEx(hdc, old.x, old.y, NULL);

	return;
}

int getStringWidth(char* str, float scale)
{
	int width = 0;
	DWORD i, j;
	int maxx;

	for(; *str; str++)
	{
		if(*str == ' ')
		{
			width += (int)(15 * scale) + 4;
			continue;
		}

		for(i = 0; i < sizeof(vchar) / sizeof(struct _tag_vchar); i++)
			if(vchar[i].index == *str)
				break;

		if(i == sizeof(vchar) / sizeof(struct _tag_vchar))
			continue;

		for(maxx = 0, j = 0; j < vchar[i].len; j++)
		{
			if(maxx < vchar[i].pos[j].x1 * scale)
				maxx = (int)(vchar[i].pos[j].x1 * scale);
			if(maxx < vchar[i].pos[j].x2 * scale)
				maxx = (int)(vchar[i].pos[j].x2 * scale);
		}

		width += maxx + 4;
	}

	return width;
}

int drawChar(int x, int y, char c, float scale)
{
	DWORD i;
	int maxx = 0;

	if(c == ' ')
		return (int)(15 * scale);

	for(i = 0; i < sizeof(vchar) / sizeof(struct _tag_vchar); i++)
		if(vchar[i].index == c)
			break;

	if(i == sizeof(vchar) / sizeof(struct _tag_vchar))
		return 0;

	c = (char)i;

	for(i = 0; i < vchar[c].len; i++)
	{
		LINE l = {(int)(vchar[c].pos[i].x1 * scale + x), (int)(vchar[c].pos[i].y1 * scale + y),
			(int)(vchar[c].pos[i].x2 * scale + x), (int)(vchar[c].pos[i].y2 * scale + y)};

		// Fix.
		if(l.x1 == l.x2)
			if(l.y1 < l.y2)
				l.y2++;
			else
				l.y2--;
		if(l.y1 == l.y2)
			if(l.x1 < l.x2)
				l.x2++;
			else
				l.x2--;
		line(hBackBuffer, l.x1, l.y1, l.x2, l.y2);

		if(maxx < vchar[c].pos[i].x1 * scale)
			maxx = (int)(vchar[c].pos[i].x1 * scale);
		if(maxx < vchar[c].pos[i].x2 * scale)
			maxx = (int)(vchar[c].pos[i].x2 * scale);
	}

	return maxx;
}

int drawString(int x, int y, char* str, float scale)
{
	int xofs = 0;

	for(; *str; str++)
	{
		xofs += drawChar(x + xofs, y, *str, scale) + 4;
	}

	return xofs;
}

void drawMyship()
{
	MoveToEx(hBackBuffer, myship.x - 8, myship.y - 4, NULL);
	LineTo(hBackBuffer, myship.x, myship.y - 4);
	LineTo(hBackBuffer, myship.x, myship.y - 8);
	LineTo(hBackBuffer, myship.x + 8, myship.y);
	LineTo(hBackBuffer, myship.x, myship.y + 8);
	LineTo(hBackBuffer, myship.x, myship.y + 4);
	LineTo(hBackBuffer, myship.x - 8, myship.y + 4);
	LineTo(hBackBuffer, myship.x - 8, myship.y - 4);

	return;
}

void initGame()
{
	score = 0;
	life = config.power;
	ships = 0;
	diecount = -1;
	level = 0;

	setGameStatus(GAMESTAT_TITLE);

#ifdef USE_MUSIC
	changeBGM(IDR_MOD1);
#endif

	return;
}

void restartGame()
{
	tick = pregametick = GetTickCount();
	setGameStatus(GAMESTAT_PLAYING);
	diecount = 0;
	levelupmsgcount = 0;
	life = config.power;

	// clear rocks
	{
		int i;

		for(i = 0; i < MAXROCKS; i++)
			rock[i].visible = FALSE;
	}

#ifdef USE_SOUND
	if(gametype == GAMETYPE_NORMAL)
		//PlaySound(MAKEINTRESOURCE(IDR_START), hInst, SND_RESOURCE | SND_ASYNC);
		wmPlayWave(wavStart);
	if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
		//PlaySound(MAKEINTRESOURCE(IDR_GRASTART), hInst, SND_RESOURCE | SND_ASYNC);
		wmPlayWave(wavGrastart);
#endif

	return;
}

void startGame()
{
	if(replaying)
		replaydata.length = 0;	// Position

	srand(GetTickCount());

	score = 0;
	level = config.startlevel;
	avoided = 0;

	if(gametype == GAMETYPE_NORMAL)
		ships = config.ships - 1;
	if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
		ships = 0;	// dead quickly

	if(recordreplay)
	{
		replaydata.repversion = REPLAYVERSION;
		replaydata.gametype = gametype;
		replaydata.length = 0;
		replaydata.alloced = REPLAYBUFFERSIZE;
		replaydata.data = malloc(replaydata.alloced);
	}

	if(gametype == GAMETYPE_NORMAL)
	{
		startwavplaying = TRUE;
#ifdef USE_MUSIC
		changeBGM(0xFFFF);
#endif
	}
#ifdef USE_MUSIC
	if(!cubecleared)
	{
		if(gametype == GAMETYPE_CUBERUSH)
			changeBGM(IDR_MOD5);
		if(gametype == GAMETYPE_CUBERUSH2)
			changeBGM(IDR_MOD11);
		if(gametype == GAMETYPE_CUBERUSH3)
			changeBGM(0xFFFF);
	}
#endif

	restartGame();

	return;
}

void endgame()
{
	setGameStatus(GAMESTAT_TITLE);

	{
		int i;

		for(i = 0; i < MAXROCKS; i++)
			rock[i].visible = FALSE;
	}

	if(recordreplay)
	{
		OPENFILENAME ofn = {0};
		char fname[MAX_PATH] = {0};

		ShowCursor(TRUE);

		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hMainWnd;
		ofn.hInstance = hInst;
		ofn.lpstrFilter = "Replay file(*.rep)\0*.rep\0";
		ofn.lpstrFile = fname;
		ofn.nMaxFile = MAX_PATH;
		ofn.lpstrTitle = "Save replay file";
		if(GetSaveFileName(&ofn))
		{
			HANDLE hf;

			if(stricmp(fname + strlen(fname) - 4, ".rep"))
				strcat(fname, ".rep");

retry:	//uwaaaa
			if(!(hf = CreateFile(fname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL)))
			{
				if(MessageBox(hMainWnd, "CreateFile error!\nretry?", "Error", MB_ICONERROR | MB_YESNO) == IDYES)
					goto retry;
			}else
			{
				char head[4];
				DWORD wrote;

				do{	// virtual try
					strncpy(head, "AKE7", 4);
					if(!WriteFile(hf, head, 4, &wrote, NULL))
					{
						MessageBox(hMainWnd, "Header-Signature write error", "Error", MB_ICONERROR | MB_OK);
						break;
					}
					if(!WriteFile(hf, &replaydata.repversion, 4, &wrote, NULL))
					{
						MessageBox(hMainWnd, "Header-Version write error", "Error", MB_ICONERROR | MB_OK);
						break;
					}
					if(!WriteFile(hf, &replaydata.gametype, 4, &wrote, NULL))
					{
						MessageBox(hMainWnd, "Header-Gametype write error", "Error", MB_ICONERROR | MB_OK);
						break;
					}
					if(!WriteFile(hf, &replaydata.length, 4, &wrote, NULL))
					{
						MessageBox(hMainWnd, "Header-Length write error", "Error", MB_ICONERROR | MB_OK);
						break;
					}
					if(!WriteFile(hf, replaydata.data, replaydata.length, &wrote, NULL))
					{
						MessageBox(hMainWnd, "ReplayData write error", "Error", MB_ICONERROR | MB_OK);
						break;
					}
				}while(0);

				CloseHandle(hf);
			}
		}

		ShowCursor(FALSE);
	}
	if(replaying || recordreplay)
		free(replaydata.data);

	if(replaying)
		replaying = FALSE;

#ifdef USE_MUSIC
	if(nowbgm == 0xFFFF)
		changeBGM(IDR_MOD1);
#endif

	return;
}

void doReplay(DWORD type)
{
	DWORD c;

	for(c = replaydata.length; c < replaydata.alloced; )
	{
		char* cur = replaydata.data + c;
		if(*(DWORD*)cur == type)
		{
			c += 8;	// head4 + len4 = 8
			cur += 8;
			switch(type)
			{
			case RECORD_FRAMEEND:
				replaydata.length = c;
				break;
			case RECORD_MYSHIP:
				myship = *(POINT*)cur;
				break;
			case RECORD_MAKEROCK:
				{
					struct _tag_rock rtemp;
					rtemp = *(struct _tag_rock*)cur;
					makeRock(rtemp.x, rtemp.y, rtemp.px, rtemp.py, rtemp.size);
					if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
						cubethrowed++;
				}
				break;
			case RECORD_CLEARED:
				setGameStatus(GAMESTAT_CLEARED);
				break;
			}
			break;
		}

		if(*(DWORD*)cur == RECORD_FRAMEEND)
			break;

		c += 4;
		cur += 4;
		c += *cur + 4;
	}

	return;
}

void timerEvent()
{
	switch(gamestatus)
	{
	case GAMESTAT_TITLE:
		if(gametype == GAMETYPE_NORMAL)
		{
			if(rnd(2) <= 1)
				makeRock(FIELDX, rnd(FIELDY), -rnd(7) - 1, 0, (int)rnd(25) + 5);
		}
		if(gametype == GAMETYPE_CUBERUSH)
			if(cubethrowed < 2)
			{
				int i;

				for(i = 0; makeRock(FIELDX, rnd(FIELDY), (float)(-7 - (int)level), 0, (int)rnd(25) + 15) && i < 100; i++);
				if(i == 100)
				{
					int i;

					for(i = 0; i < MAXROCKS; i++)
						rock[i].visible = FALSE;
				}
				else
					cubethrowed++;
			}
		if(gametype == GAMETYPE_CUBERUSH2)
			if(cubethrowed < 3)
			{
				int i;

				for(i = 0; makeRock(FIELDX, rnd(FIELDY), (float)(-7 - (int)level), 0, (int)rnd(25) + 15) && i < 100; i++);
				if(i == 100)
				{
					int i;

					for(i = 0; i < MAXROCKS; i++)
						rock[i].visible = FALSE;
				}
				else
					cubethrowed++;
			}
		if(gametype == GAMETYPE_CUBERUSH3)
			if(cubethrowed < 3)
			{
				int i;

				for(i = 0; makeRock(FIELDX, rnd(FIELDY), (float)(-7 - (int)level), 0, (int)rnd(25) + 15) && i < 100; i++);
				if(i == 100)
				{
					int i;

					for(i = 0; i < MAXROCKS; i++)
						rock[i].visible = FALSE;
				}
				else
					cubethrowed++;
			}
		moveRock();
		hitTest();
		break;
	case GAMESTAT_PLAYING:
		if(!replaying)
		{
			if(gametype == GAMETYPE_NORMAL)
			{
				if(rnd((int)bigger(5 - ((float)level / 10), 2)) < 1 && config.begindelay < elapsed)
					makeRock(FIELDX, rnd(FIELDY), -rnd(level / 3 + 1) - 1, pmrnd((float)bigger(((int)level - 5) / 3, 0)), (int)rnd(smaller(level, 45)) + 5);
			}
			if(gametype == GAMETYPE_CUBERUSH)
				if(cubethrowed < 2)
				{
					int i;

					if(cubecount % 2 == 1 || makeRock(FIELDX, (float)myship.y, (float)(-7 - (int)level*2), 0, (int)rnd(15) + 10))
					{
						for(i = 0; i < 100; i++)
							if(!makeRock(FIELDX, rnd(FIELDY), (float)(-7 - (int)level*2), 0, (int)rnd(15) + 10))
								break;
						if(i == 100)
						{
							cubecleared = TRUE;
#ifdef USE_MUSIC
							changeBGM(IDR_MOD2);
#endif
							setGameStatus(GAMESTAT_CLEARED);
							record(RECORD_CLEARED, 0, 0);
						}
						else
						{
							cubethrowed++;
							cubecount++;
						}
					}else if(cubecount % 2 == 0)
					{
						cubethrowed++;
						cubecount++;
					}
				}
			if(gametype == GAMETYPE_CUBERUSH2)
				if(cubethrowed < 3)
				{
					int i;

					for(i = 0; i < 100; i++)
						if(!makeRock(FIELDX, rnd(FIELDY), (float)(-7 - (int)level), 0, (int)rnd(15) + 10))
							break;
					if(i == 100)
					{
						cubecleared = TRUE;
#ifdef USE_MUSIC
						changeBGM(IDR_MOD10);
#endif
						setGameStatus(GAMESTAT_CLEARED);
						record(RECORD_CLEARED, 0, 0);
					}
					else
					{
						cubethrowed++;
						cubecount++;
					}
				}
			if(gametype == GAMETYPE_CUBERUSH3)
				if(cubethrowed < 3)
				{
					int i;
					float y = rnd(FIELDY);
					double r = getRadian((myship.x - FIELDX), myship.y - y);

					for(i = 0; i < 100; i++)
						if(!makeRock(FIELDX, y, (float)(cos(r) * (int)level*5), (float)(sin(r) * (int)level*5), (int)rnd(15) + 10))
							break;
					if(i == 100)
					{
						cubecleared = TRUE;
#ifdef USE_MUSIC
						changeBGM(0xFFFF);
#endif
						setGameStatus(GAMESTAT_CLEARED);
						record(RECORD_CLEARED, 0, 0);
					}
					else
					{
						cubethrowed++;
						cubecount++;
					}
				}
		}

		if(replaying)
		{
			doReplay(RECORD_MAKEROCK);
			doReplay(RECORD_CLEARED);
		}

		if(gametype == GAMETYPE_NORMAL)
		{
			DWORD next = 10;
			DWORD plus = 100;
			DWORD i;

			for(i = 0; i < level; i++)
			{
				next += plus;
				if(25 < plus)
					plus -= 2;
			}

			if(next < avoided)
			{
				level++;
				levelupmsgcount = 30;
#ifdef USE_MUSIC
				switch(level)
				{
				case 7:
					changeBGM(IDR_MOD7);
					break;
				case 15:
					changeBGM(IDR_MOD4);
					break;
				case 25:
					changeBGM(IDR_MOD6);
					break;
				case 40:
					changeBGM(IDR_MOD8);
					break;
				case 60:
					changeBGM(IDR_MOD12);
					break;
				}
#endif
			}
		}
		if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
		{
			if(level * 5 <= avoided)
			{
				level++;
				levelupmsgcount = 30;
			}
		}

		moveRock();
		if(!replaying)
			myship = mcursor;
		else
			doReplay(RECORD_MYSHIP);

		if(myship.x < 0)
			myship.x = 0;
		if(myship.y < 0)
			myship.y = 0;
		if(FIELDX <= myship.x)
			myship.x = FIELDX - 1;
		if(FIELDY <= myship.y)
			myship.y = FIELDY - 1;
		record(RECORD_MYSHIP, &myship, sizeof(myship));
		hitTest();

		if(diecount)
		{
			if(diecount != -1)
			{
				diecount--;
#ifdef USE_SOUND
				if(!diecount)
					//PlaySound(MAKEINTRESOURCE(IDR_RESTORE), hInst, SND_RESOURCE | SND_ASYNC);
					wmPlayWave(wavRestore);
#endif
			}
		}

		record(RECORD_FRAMEEND, 0, 0);
		if(replaying)
			doReplay(RECORD_FRAMEEND);

		if(gametype == GAMETYPE_NORMAL)
			if(startwavplaying && elapsed > 6000)
			{
				startwavplaying = FALSE;
#ifdef USE_MUSIC
				changeBGM(IDR_MOD3);
#endif
			}

		break;
	case GAMESTAT_DEAD:
		if(TIUNTIUNTIME < elapsed)
		{
			if(--ships >= 0)
				restartGame();
			else
				setGameStatus(GAMESTAT_GAMEOVER);
		}
		break;
	case GAMESTAT_GAMEOVER:
	case GAMESTAT_CLEARED:
		moveRock();
		hitTest();
		if(7500 < elapsed)
			endgame();
		if((gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3) && avoided > 0)
			avoided--;	// back line
		break;
	case GAMESTAT_DIPSWITCH:
		break;
	}

#ifdef USE_MUSIC
	if(bgmphase != BGMPHASE_END)
	{
		bgmtitlecount--;

		if(bgmtitlecount == 0)
			switch(bgmphase)
			{
			case BGMPHASE_FADEIN:
				bgmphase = BGMPHASE_SHOWING;
				bgmtitlecount = BGMTC_SHOW_TIME;
				break;
			case BGMPHASE_SHOWING:
				bgmphase = BGMPHASE_FADEOUT;
				bgmtitlecount = BGMTC_FADE_TIME;
				break;
			case BGMPHASE_FADEOUT:
				bgmphase = BGMPHASE_END;
				break;
			}
	}
#endif

	return;
}

void drawGUI(void)
{
	DWORD i;
	HPEN hpold = SelectPen(hBackBuffer, PS_SOLID, config.linewidth, RGB(255, 255, 255));

	for(i = 0; i < sizeof(gui) / sizeof(struct _tag_gui); i++)
	{
		if(gui[i].type != GUITYPE_LABEL && gui[i].type != GUITYPE_BIGLABEL)
		{
			line(hBackBuffer, GUIOFFSETX + gui[i].rc.left, GUIOFFSETY + gui[i].rc.top, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right, GUIOFFSETY + gui[i].rc.top);
			line(hBackBuffer, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right, GUIOFFSETY + gui[i].rc.top, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom);
			line(hBackBuffer, GUIOFFSETX + gui[i].rc.left, GUIOFFSETY + gui[i].rc.top, GUIOFFSETX + gui[i].rc.left, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom);
			line(hBackBuffer, GUIOFFSETX + gui[i].rc.left, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right + 1, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom);
		}
		if(i == LOWORD(guiactive))
			FillRectangleColor(hBackBuffer, GUIOFFSETX + gui[i].rc.left + 1, GUIOFFSETY + gui[i].rc.top + 1, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom, RGB(64, 64, 64));

		switch(gui[i].type)
		{
		case GUITYPE_LABEL:
			drawString(GUIOFFSETX + gui[i].rc.left + 2, GUIOFFSETY + gui[i].rc.top + 2, gui[i].text, 0.5);
			break;
		case GUITYPE_BIGLABEL:
			drawString(GUIOFFSETX + gui[i].rc.left + 2, GUIOFFSETY + gui[i].rc.top + 2, gui[i].text, 1.0);
			break;
		case GUITYPE_INPUT:
			{
				char tmp[80];

				wsprintf(tmp, "%u", *(DWORD*)gui[i].text);
				drawString(GUIOFFSETX + gui[i].rc.left + 2, GUIOFFSETY + gui[i].rc.top + 2, tmp, 0.5);
			}
			break;
		case GUITYPE_BUTTON:
			drawString(GUIOFFSETX + gui[i].rc.left + 2 + (gui[i].rc.right - getStringWidth(gui[i].text, 0.5)) / 2, GUIOFFSETY + gui[i].rc.top + 2, gui[i].text, 0.5);
			break;
		case GUITYPE_LIST:
			{
				DWORD j;
				char* tx = gui[i].text;

				line(hBackBuffer, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right - GUISCROLLBARSIZE, GUIOFFSETY + gui[i].rc.top, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right - GUISCROLLBARSIZE, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom);
				line(hBackBuffer, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right - GUISCROLLBARSIZE, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom / 2, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right, GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom / 2);

				for(j = 0; j < gui[i].scroll && strlen(tx); j++)
					tx += strlen(tx) + 1;

				for(j = 0; j < (DWORD)(gui[i].rc.bottom / 15) && strlen(tx); j++)
				{
					if(j + gui[i].scroll == gui[i].val)
						FillRectangleColor(hBackBuffer, GUIOFFSETX + gui[i].rc.left + 1, GUIOFFSETY + gui[i].rc.top + 1 + j * 15, GUIOFFSETX + gui[i].rc.left + gui[i].rc.right - GUISCROLLBARSIZE, GUIOFFSETY + gui[i].rc.top + 1 + (j + 1) * 15, RGB(128, 128, 128));
					drawString(GUIOFFSETX + gui[i].rc.left + 2, GUIOFFSETY + gui[i].rc.top + 2 + j * 15, tx, 0.5);

					tx += strlen(tx) + 1;
				}
			}
			break;
		}
	}

	RestoreObject(hBackBuffer, hpold);

	return;
}
DWORD hitGUI(int x, int y)
{
	DWORD i;

	for(i = 0; i < sizeof(gui) / sizeof(struct _tag_gui); i++)
		if(gui[i].type != GUITYPE_LABEL)
			if(	GUIOFFSETX + gui[i].rc.left <= x &&
				GUIOFFSETY + gui[i].rc.top <= y &&
				x < GUIOFFSETX + gui[i].rc.left + gui[i].rc.right &&
				y < GUIOFFSETY + gui[i].rc.top + gui[i].rc.bottom)
			{
				return i;
			}

	return 0xFFFF;
}

void drawAll(void)
{
	HPEN hpold;

	hpold = SelectPen(hBackBuffer, PS_SOLID, config.linewidth, RGB(255, 255, 255));

	// Clear.
	FillRectangle(hBackBuffer, 0, 0, FIELDX, FIELDY, GetStockObject(BLACK_BRUSH));

	// deadline
	if((gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3) && (gamestatus == GAMESTAT_PLAYING || gamestatus == GAMESTAT_CLEARED || gamestatus == GAMESTAT_DEAD || gamestatus == GAMESTAT_GAMEOVER))
		line(hBackBuffer, avoided * 2, 0, avoided * 2, FIELDY);

	if(gamestatus != GAMESTAT_DIPSWITCH)
		drawRock();

	//drawMyship
	if(gamestatus == GAMESTAT_PLAYING || gamestatus == GAMESTAT_CLEARED)
		if(!diecount)
			drawMyship();
		else
		{
			if(diecount != -1)
			{
				if(diecount % 2 == 0)
					drawMyship();
			}
		}

	// Status line
	if(gamestatus != GAMESTAT_DIPSWITCH)
	{
		char str[80];
		int sh = bigger(ships, 0);

		if(gametype == GAMETYPE_NORMAL)
			wsprintf(str, "SCORE:%07u SHIPS:%u LIFE:%u%% LEVEL:%u", score, sh, life * 100 / config.power, level);
		if(gametype == GAMETYPE_CUBERUSH || gametype == GAMETYPE_CUBERUSH2 || gametype == GAMETYPE_CUBERUSH3)
		{
			int i, meteos = 0;	// rocksƂ܂킵B

			for(i = 0; i < MAXROCKS; i++)
				if(rock[i].visible)
					meteos++;

			wsprintf(str, "LEFT:%03d LEVEL:%u", MAXROCKS - meteos, level);
		}
		drawString(10, 10, str, 0.5);
	}

	// Draw title, gaming space, etc...
	switch(gamestatus)
	{
	case GAMESTAT_DIPSWITCH:
		drawString(10, 10, "DIP SWITCH", 1.0);
		drawString(10, 35, "PRESS ESC TO QUIT", 0.5);

		drawString(10 + getStringWidth("DIP SWITCH ", 1.0), 30 - (int)(20 * 0.3f) * 2 - 4, "WE DO NOT GUARANTEE!", 0.3f);
		{
			version v = getVersion();
			char tmp[80];

			wsprintf(tmp, "AKE2007 VERSION %d.%d.%d.%d", v.major, v.minor, v.patch, v.build);
			drawString(10 + getStringWidth("DIP SWITCH ", 1.0), 30 - (int)(20 * 0.3f), tmp, 0.3f);
		}

		drawGUI();
		break;
	case GAMESTAT_TITLE:
#ifdef _DEBUG
		drawString((FIELDX - getStringWidth("DEBUG VERSION OF", 0.5)) / 2, FIELDY / 2 - 35, "DEBUG VERSION OF", 0.5);
#endif
		drawString((FIELDX - getStringWidth("AKEOME 2007", 1.5)) / 2, FIELDY / 2 - 20, "AKEOME 2007", 1.5);
		drawString((FIELDX - getStringWidth("AVOID METEOS", 1)) / 2, FIELDY / 2 + 20, "AVOID METEOS", 1);
		if(elapsed % 1000 / 500 >= 1)
			drawString((FIELDX - getStringWidth("PRESS SPACE", 0.5)) / 2, FIELDY / 2 + 50, "PRESS SPACE", 0.5);

		if(gametype == GAMETYPE_NORMAL)
			drawString((FIELDX - getStringWidth("PRESS PAGEUP TO SWITCH GAMETYPE", 0.3f)) / 2, FIELDY - 30, "PRESS PAGEUP TO SWITCH GAMETYPE", 0.3f);
		if(gametype == GAMETYPE_CUBERUSH)
			drawString((FIELDX - getStringWidth("METEO RUSH", 0.5)) / 2, FIELDY / 2 + 100, "METEO RUSH", 0.5);
		if(gametype == GAMETYPE_CUBERUSH2)
			drawString((FIELDX - getStringWidth("METEO RUSH ][", 0.5)) / 2, FIELDY / 2 + 100, "METEO RUSH ][", 0.5);
		if(gametype == GAMETYPE_CUBERUSH3)
			drawString((FIELDX - getStringWidth("METEO RUSH ]|[", 0.5)) / 2, FIELDY / 2 + 100, "METEO RUSH ]|[", 0.5);

		if(recordreplay)
			drawString((FIELDX - getStringWidth("REPLAY RECORD ON", 0.3f)) / 2, FIELDY - 10, "REPLAY RECORD ON", 0.3f);

#ifdef USE_MUSIC
		{
			char tmp[80];
			sprintf(tmp, "VOL: %d%%", (int)(FSOUND_GetMasterVolume() * 100));
			drawString(FIELDX - 1 - getStringWidth(tmp, 0.3f) , FIELDY - 11, tmp, 0.3f);
		}
#endif

		break;
	case GAMESTAT_PLAYING:
#ifdef _DEBUG
		{
			char str[80];

			wsprintf(str, "AVOIDED:%u", avoided);
			drawString(10, 30, str, 0.5);
		}
#endif

		if(levelupmsgcount)
		{
			drawString((FIELDX - getStringWidth("LEVEL UP!", 1)) / 2, (FIELDY - 15) / 2, "LEVEL UP!", 1);
			levelupmsgcount--;
		}

		if(recordreplay && elapsed % 1000 / 500 >= 1)
			drawString(FIELDX - getStringWidth("RECORDING", 0.3f), FIELDY - 10, "RECORDING", 0.3f);
		if(replaying && elapsed % 1000 / 500 >= 1)
			drawString(FIELDX - getStringWidth("PLAYING", 0.3f), FIELDY - 10, "PLAYING", 0.3f);

		break;
	case GAMESTAT_DEAD:
		// tiuntiun
		if(gametype == GAMETYPE_NORMAL)
		{
			int i;
			int d = elapsed / 20;
			int r = 10 - (elapsed % 10);

			for(i = 0; i < 360; i += 360 / 8)
			{
				int x = myship.x + (int)(cos(i * PI/180) * d);
				int y = myship.y + (int)(sin(i * PI/180) * d);

				Ellipse(hBackBuffer, x - r, y - r, x + r, y + r);
			}
		}
		break;
	case GAMESTAT_GAMEOVER:
		// tiuntiun
		if(gametype == GAMETYPE_NORMAL)
		{
			int i;
			int d = (elapsed+TIUNTIUNTIME) / 20;
			int r = 10 - (elapsed % 10);

			for(i = 0; i < 360; i += 360 / 8)
			{
				int x = myship.x + (int)(cos(i * PI/180) * d);
				int y = myship.y + (int)(sin(i * PI/180) * d);

				Ellipse(hBackBuffer, x - r, y - r, x + r, y + r);
			}
		}
		{
			float sc = smaller((float)elapsed / 250, 3);
			drawString((FIELDX - getStringWidth("GAME OVER", sc)) / 2, (FIELDY - (int)(15 * sc)) / 2, "GAME OVER", sc);
		}
		break;
	case GAMESTAT_CLEARED:
		{
			float sc = smaller((float)elapsed / 250, 3);
			drawString((FIELDX - getStringWidth("GAME CLEAR", sc)) / 2, (FIELDY - (int)(15 * sc)) / 2, "GAME CLEAR", sc);
		}
		break;
	}

	// systemdraw

	// FPS
	{
		char str[80];

		wsprintf(str, "FPS: %u", fps);
		drawString(FIELDX - 10 - getStringWidth(str, 0.5), 10, str, 0.5);
	}

#ifdef USE_MUSIC
	if(bgmphase != BGMPHASE_END)
	{
		char str[80];
		char up[21];
		char *title;

		title = FMUSIC_GetTitle(mod);
		if(title)
		{
			strcpy(up, title);
			strupr(up);
			up[strlen(title)] = '\0';

			wsprintf(str, "MUSIC: %s", up);
			switch(bgmphase)
			{
			case BGMPHASE_FADEIN:
				drawString(10, FIELDY - (BGMTC_FADE_TIME - bgmtitlecount) * 20 / BGMTC_FADE_TIME, str, 0.5);
				break;
			case BGMPHASE_SHOWING:
				drawString(10, FIELDY - 20, str, 0.5);
				break;
			case BGMPHASE_FADEOUT:
				drawString(10, FIELDY - bgmtitlecount * 20 / BGMTC_FADE_TIME, str, 0.5);
				break;
			}
		}
	}
#endif

	if(gamestatus == GAMESTAT_TITLE || gamestatus == GAMESTAT_GAMEOVER || gamestatus == GAMESTAT_DIPSWITCH || paused)
		drawChar(mcursor.x, mcursor.y, '\x80', 1);

	RestoreObject(hBackBuffer, hpold);

	return;
}

// Open window center.
HWND CreateWindowCx(DWORD dwExStyle, LPCTSTR lpClassName, LPCTSTR lpWindowName, DWORD dwStyle, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam)
{
	RECT drc, rc;

	SystemParametersInfo(SPI_GETWORKAREA, 0, &drc, 0);

	rc.left = (drc.right - drc.left - nWidth) / 2;
	rc.top = (drc.bottom - drc.top - nHeight) / 2;
	rc.right = rc.left + nWidth;
	rc.bottom = rc.top + nHeight;

	{
		DWORD ds = dwStyle;

		// MicrosoftݏoŋNX̃oÔ߂ɂ킴킴킴킴IIIIII
		// dwStyle & WS_CAPTIONƂĂ܂ƕЕĂʂĂ܂߁B
		if(dwStyle & WS_BORDER && dwStyle & WS_DLGFRAME)
			ds |= WS_OVERLAPPEDWINDOW & ~WS_SIZEBOX;

		AdjustWindowRectEx(&rc, ds, hMenu != NULL, dwExStyle);
	}

	return CreateWindowEx(dwExStyle, lpClassName, lpWindowName, dwStyle, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, hWndParent, hMenu, hInstance, lpParam);
}

BOOL changeDisplayMode(BOOL full)
{
	static DEVMODE predm = {0};

	if(!full)
	{
		// Back to original settings
		if(predm.dmSize)
		{
			ChangeDisplaySettings(&predm, CDS_FULLSCREEN);
			predm.dmSize = 0;
		}
	}else
	{
		// Save current settings
		if(!predm.dmSize)
		{
			HDC hdc = GetDC(NULL);

			predm.dmSize = sizeof(predm);
			predm.dmPelsWidth = GetDeviceCaps(hdc, HORZRES);
			predm.dmPelsHeight = GetDeviceCaps(hdc, VERTRES);
			predm.dmBitsPerPel = GetDeviceCaps(hdc, BITSPIXEL);
			// bpp, refrate
			predm.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;

			// for Win2k
			if((GetVersion() & 0x80000000) == 0)
			{
				predm.dmFields |= DM_DISPLAYFREQUENCY;
				predm.dmDisplayFrequency = GetDeviceCaps(hdc, VREFRESH);
			}

			ReleaseDC(NULL, hdc);
		}

		// Restore current settings
		{
			DEVMODE dm = {0};

			dm.dmSize = sizeof(dm);
			dm.dmPelsWidth = 640;
			dm.dmPelsHeight = 480;
			dm.dmBitsPerPel = 16;
			dm.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT | DM_BITSPERPEL;
			if((GetVersion() & 0x80000000) == 0)
			{
				predm.dmFields |= DM_DISPLAYFREQUENCY;
				predm.dmDisplayFrequency = 60;
			}
			if(ChangeDisplaySettings(&dm, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
				return TRUE;
		}
	}

	return FALSE;
}

BOOL changeScreenMode(BOOL full)
{
	if(hMainWnd)
		DestroyWindow(hMainWnd);

	if(!full)
	{
		if(changeDisplayMode(FALSE))
			return TRUE;

		if(!(hMainWnd = CreateWindowCx(0, "ake2007wc", "ake2007 - Avoid meteos!!", WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX, FIELDX, FIELDY, NULL, NULL, hInst, NULL)))
			return TRUE;

		ShowWindow(hMainWnd, SW_SHOWNORMAL);
	}else
	{
		if(changeDisplayMode(TRUE))
			return TRUE;

		if(!(hMainWnd = CreateWindowEx(0, "ake2007wc", "ake2007 - Avoid meteos!!", WS_POPUP | WS_SYSMENU, 0, 0, FIELDX, FIELDY, NULL, NULL, hInst, NULL)))
			return TRUE;

		ShowWindow(hMainWnd, SW_SHOWMAXIMIZED);
	}

	fullscreen = full;

	return FALSE;
}

void makeSysMenu()
{
	int i;
	HMENU hm = GetSystemMenu(hMainWnd, FALSE);

	for(i = 0; i < GetMenuItemCount(hm); i++)
	{
		MENUITEMINFO mii = {0};

		mii.cbSize = sizeof(mii);
		mii.fMask = MIIM_ID | MIIM_STATE;
		GetMenuItemInfo(hm, i, TRUE, &mii);
		switch(mii.wID)
		{
		case SC_SIZE:
			RemoveMenu(hm, i, MF_BYPOSITION);
			break;
		case SC_MAXIMIZE:
			if(!fullscreen)
				mii.fState &= ~MFS_DISABLED;
			else
				mii.fState |= MFS_DISABLED;
			SetMenuItemInfo(hm, i, TRUE, &mii);
			break;
		case SC_MINIMIZE:
			if(IsIconic(hMainWnd))
				mii.fState |= MFS_DISABLED;
			else
				mii.fState &= ~MFS_DISABLED;
			SetMenuItemInfo(hm, i, TRUE, &mii);
			break;
		case SC_RESTORE:
			if(IsIconic(hMainWnd) || IsZoomed(hMainWnd) || fullscreen)
				mii.fState &= ~MFS_DISABLED;
			else
				mii.fState |= MFS_DISABLED;
			SetMenuItemInfo(hm, i, TRUE, &mii);
			break;
		}
	}

	return;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static int dipsequence = 0;

	switch(msg)
	{
	case WM_CREATE:
		SetTimer(hWnd, 1, 1000 / 60, NULL);	// 60FPS
		break;
	case WM_TIMER:
		tick = GetTickCount();

		// Check FPS
		fpscounter++;
		if(fpstick + 1000 < tick)
		{
			fps = fpscounter;
			fpscounter = 0;
			fpstick = tick;
		}

		// MouseCursor Position
		GetCursorPos(&mcursor);
		ScreenToClient(hMainWnd, &mcursor);

		gametick = tick;
		if(!paused)
		{
			elapsed += gametick - pregametick;

			timerEvent();
		}
		pregametick = gametick;

		drawAll();
		/*
		{
			char str[80];
			wsprintf(str, "%d %d", tick, elapsed);
			SetWindowText(hWnd, str);
		}
		*/
		InvalidateRect(hWnd, NULL, FALSE);

		break;
	case WM_PAINT:
		{
			HDC hdc;
			PAINTSTRUCT ps;

			hdc = BeginPaint(hWnd, &ps);

			BitBlt(hdc, 0, 0, FIELDX, FIELDY, hBackBuffer, 0, 0, SRCCOPY);

			EndPaint(hWnd, &ps);
		}
		return 0;
	case WM_MOUSEACTIVATE:	// Eat activating MouseMessage!!
		return MA_ACTIVATEANDEAT;
	case WM_ACTIVATE:
		makeSysMenu();

		if(LOWORD(wParam))
		{
			paused = FALSE;
#ifdef USE_SOUND
			wmUnpauseWaveOut();
#endif

			// ߂
			if(gamestatus == GAMESTAT_PLAYING)
			{
				POINT mc = myship;
				ClientToScreen(hMainWnd, &mc);
				SetCursorPos(mc.x, mc.y);
			}
		}else
		{
			paused = TRUE;
#ifdef USE_SOUND
			wmPauseWaveOut();
#endif
		}
		break;
	case WM_LBUTTONDOWN:
		if(gamestatus == GAMESTAT_DIPSWITCH)
		{
			guiactive = hitGUI(LOWORD(lParam), HIWORD(lParam));
			inputsequence = FALSE;

			if(LOWORD(guiactive) != 0xFFFF)
			{
				if(gui[LOWORD(guiactive)].func)
				{
					POINT p = {LOWORD(lParam) - gui[LOWORD(guiactive)].rc.left - GUIOFFSETX, HIWORD(lParam) - gui[LOWORD(guiactive)].rc.top - GUIOFFSETY};

					gui[LOWORD(guiactive)].func(&gui[LOWORD(guiactive)], &p);
				}
			}
		}
		if(gamestatus == GAMESTAT_TITLE || gamestatus == GAMESTAT_GAMEOVER || gamestatus == GAMESTAT_CLEARED)
			PostMessage(hWnd, WM_KEYDOWN, VK_SPACE, 0);
		break;
	case WM_MOUSEWHEEL:
		if(gamestatus == GAMESTAT_DIPSWITCH)
		{
			POINT p = {LOWORD(lParam), HIWORD(lParam)};

			ScreenToClient(hMainWnd, &p);
			guiactive = hitGUI(p.x, p.y);
			inputsequence = FALSE;

			if(LOWORD(guiactive) != 0xFFFF)
				if(gui[LOWORD(guiactive)].wheel)
					gui[LOWORD(guiactive)].wheel(&gui[LOWORD(guiactive)], (short)HIWORD(wParam));
		}
		break;
	case WM_KEYDOWN:
		if(lParam & 0x40000000)	// if repeat
			break;

		if(gamestatus == GAMESTAT_DIPSWITCH)
		{
			switch((int)wParam)
			{
			case VK_ESCAPE:
				if(gamestatus == GAMESTAT_DIPSWITCH)
				{
					setGameStatus(GAMESTAT_TITLE);
#ifdef USE_MUSIC
					changeBGM(IDR_MOD1);
#endif
				}
				break;
			}
			if('0' <= (int)wParam && (int)wParam <= '9' && guiactive != -1)
			{
				if(gui[guiactive].type == GUITYPE_INPUT)
				{
					if(!inputsequence)
					{
						inputsequence = TRUE;
						*(DWORD*)gui[guiactive].text = (int)wParam - '0';
					}else
					{
						char str[16];

						sprintf(str, "%u%c", *(DWORD*)gui[guiactive].text, (int)wParam);
						*(DWORD*)gui[guiactive].text = atoi(str);
					}
				}
			}
		}

#ifdef USE_MUSIC
		if(wParam == VK_UP)
			FSOUND_SetMasterVolume(FSOUND_GetMasterVolume() + 0.1f);
		if(wParam == VK_DOWN)
			FSOUND_SetMasterVolume(FSOUND_GetMasterVolume() - 0.1f);
#endif

		if(gamestatus == GAMESTAT_TITLE)
		{
#ifdef _DEBUG
			if(dipsequence == 0)
				if(wParam == VK_RETURN)
					dipsequence++;
				else
					dipsequence = 0;

			if(dipsequence == 1)
#else
			if(dipsequence == 10)
				if(wParam == VK_RETURN)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 9)
				if(wParam == 'A')
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 8)
				if(wParam == 'B')
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 7)
				if(wParam == VK_RIGHT)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 6)
				if(wParam == VK_LEFT)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 5)
				if(wParam == VK_RIGHT)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 4)
				if(wParam == VK_LEFT)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 3)
				if(wParam == VK_DOWN)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 2)
				if(wParam == VK_DOWN)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 1)
				if(wParam == VK_UP)
					dipsequence++;
				else
					dipsequence = 0;
			if(dipsequence == 0)
				if(wParam == VK_UP)
					dipsequence++;
				else
					dipsequence = 0;

			if(dipsequence == 11)
#endif
			{
				dipsequence = 0;
				guiactive = 0xFFFF;
#ifdef USE_MUSIC
				changeBGM(IDR_MOD9);
#endif
				setGameStatus(GAMESTAT_DIPSWITCH);
			}
		}

		switch((int)wParam)
		{
		case VK_SPACE:
			switch(gamestatus)
			{
			case GAMESTAT_TITLE:
				startGame();
				break;
			case GAMESTAT_GAMEOVER:
			case GAMESTAT_CLEARED:
				elapsed = 7500;
				break;
			}
			break;
		case VK_PRIOR:
			if(gamestatus == GAMESTAT_TITLE)
			{
				gametype++;
				// sirusi
				_asm{
					nop
					nop
					nop
				}
#ifndef _DEBUG
				if(gametype == GAMETYPE_CUBERUSH3)
					gametype++;
#endif
				//sirusi
				_asm{
					nop
					nop
					nop
				}
				if(gametype == GAMETYPE_GTEOL)
					gametype = 0;

				cubethrowed = 0;

				{
					int i;

					for(i = 0; i < MAXROCKS; i++)
						rock[i].visible = FALSE;
				}

#ifdef USE_SOUND
				//PlaySound(MAKEINTRESOURCE(IDR_GRASEL), hInst, SND_RESOURCE | SND_ASYNC);
				wmPlayWave(wavGrasel);
#endif

				cubecleared = FALSE;
			}
			break;
		case VK_NEXT:
			if(gamestatus == GAMESTAT_TITLE)
			{
				recordreplay = !recordreplay;

#ifdef USE_SOUND
				if(recordreplay)
					//PlaySound(MAKEINTRESOURCE(IDR_SWITCH), hInst, SND_RESOURCE | SND_ASYNC);
					wmPlayWave(wavSwitch);
#endif
			}
			break;
		case VK_END:
			if(gamestatus == GAMESTAT_TITLE)
			{
				OPENFILENAME ofn = {0};
				char fname[MAX_PATH] = {0};

				ShowCursor(TRUE);

				ofn.lStructSize = sizeof(ofn);
				ofn.hwndOwner = hMainWnd;
				ofn.hInstance = hInst;
				ofn.lpstrFilter = "Replay file(*.rep)\0*.rep\0";
				ofn.lpstrFile = fname;
				ofn.nMaxFile = MAX_PATH;
				ofn.lpstrTitle = "Open replay file";
				ofn.Flags = OFN_FILEMUSTEXIST;
				if(GetOpenFileName(&ofn))
				{
					HANDLE hf;
					DWORD read;

					if(!(hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)))
						MessageBox(hMainWnd, "Replay file open failed", "Error", MB_ICONERROR | MB_OK);
					else
					{
						char buf[4];

						do{	// virtual try
							if(!ReadFile(hf, buf, 4, &read, NULL))
							{
								MessageBox(hMainWnd, "Header-Signature read failed", "Error", MB_ICONERROR | MB_OK);
								break;
							}
							if(strncmp(buf, "AKE7", 4))
							{
								MessageBox(hMainWnd, "This is not replay file", "Error", MB_ICONERROR | MB_OK);
								break;
							}
							if(!ReadFile(hf, &replaydata.repversion, 4, &read, NULL))
							{
								MessageBox(hMainWnd, "Header-Version read failed", "Error", MB_ICONERROR | MB_OK);
								break;
							}
							if(replaydata.repversion != REPLAYVERSION)
							{
								MessageBox(hMainWnd, "Sorry, Recorded software is old.\nCan't play.", "Error", MB_ICONERROR | MB_OK);
								break;
							}
							if(!ReadFile(hf, &replaydata.gametype, 4, &read, NULL))
							{
								MessageBox(hMainWnd, "Header-Gametype read failed", "Error", MB_ICONERROR | MB_OK);
								break;
							}
							if(!ReadFile(hf, &replaydata.alloced, 4, &read, NULL))
							{
								MessageBox(hMainWnd, "Header-Length read failed", "Error", MB_ICONERROR | MB_OK);
								break;
							}
							if(!(replaydata.data = malloc(replaydata.alloced)))
							{
								MessageBox(hMainWnd, "Data memory allocation failed", "Error", MB_ICONERROR | MB_OK);
								break;
							}
							if(!ReadFile(hf, replaydata.data, replaydata.alloced, &read, NULL))
							{
								MessageBox(hMainWnd, "Replay-data read failed", "Error", MB_ICONERROR | MB_OK);
								break;
							}

							recordreplay = FALSE;
							replaying = TRUE;

							gametype = replaydata.gametype;

							startGame();
						}while(0);

						CloseHandle(hf);
					}
				}

				ShowCursor(FALSE);
			}
			break;
		case VK_ESCAPE:
			if(gamestatus == GAMESTAT_PLAYING)
				endgame();
			break;
#ifdef _DEBUG
#ifdef USE_MUSIC
		case VK_INSERT:
			{
				int nb = nowbgm;

				nb--;
				if(nb == -1)
					nb = sizeof(bgms) / sizeof(int) - 1;
				changeBGM(bgms[nb]);
			}
			break;
		case VK_DELETE:
			{
				int nb = nowbgm;

				nb++;
				if(nb == sizeof(bgms) / sizeof(int))
					nb = 0;
				changeBGM(bgms[nb]);
			}
			break;
#endif
#endif
		}
		break;
	case WM_CLOSE:
		PostQuitMessage(0);
		break;
	case WM_DESTROY:
		KillTimer(hWnd, 1);
		break;
	case WM_CONTEXTMENU:
		if(SendMessage(hMainWnd, WM_NCHITTEST, 0, lParam) == HTCLIENT)	// Ȃ񂩓dɏôŁB
		{
			PostMessage(hMainWnd, WM_INITMENU, (WPARAM)GetSystemMenu(hMainWnd, FALSE), 0);
			PostMessage(hMainWnd, WM_INITMENUPOPUP, (WPARAM)GetSystemMenu(hMainWnd, FALSE), MAKELONG(0, TRUE));
			PostMessage(hMainWnd, WM_SYSCOMMAND, (WPARAM)TrackPopupMenu(GetSystemMenu(hMainWnd, FALSE), TPM_RETURNCMD | TPM_NONOTIFY, LOWORD(lParam), HIWORD(lParam), 0, hMainWnd, NULL), 0);
			PostMessage(hMainWnd, WM_UNINITMENUPOPUP, 0, 0);
		}
		break;
	case WM_INITMENUPOPUP:
		ShowCursor(TRUE);
		makeSysMenu();
		break;
	case WM_UNINITMENUPOPUP:
		ShowCursor(FALSE);
		break;
	case WM_SYSCOMMAND:
		if((wParam & 0xFFF0) == SC_MAXIMIZE)
		{
			changeScreenMode(TRUE);
			ShowCursor(FALSE);
			return 0;
		}
		if((wParam & 0xFFF0) == SC_MINIMIZE)
			if(fullscreen)
			{
				changeDisplayMode(FALSE);
				ShowCursor(FALSE);
			}
		if((wParam & 0xFFF0) == SC_RESTORE)
		{
			if(IsZoomed(hWnd))
			{
				changeScreenMode(FALSE);
				ShowCursor(FALSE);
				return 0;
			}
			if(IsIconic(hWnd) && fullscreen)
			{
				changeDisplayMode(TRUE);
				ShowCursor(FALSE);
			}
		}
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

int initWindow()
{
	WNDCLASSEX wc = {0};

	wc.cbSize = sizeof(wc);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_MAINICON));
	wc.hInstance = hInst;
	wc.lpfnWndProc = MainWndProc;
	wc.lpszClassName = "ake2007wc";
	if(!RegisterClassEx(&wc))
		return 1;

	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	MSG msg;
	HBITMAP hbold;

	hInst = hInstance;

	if(initWindow())
	{
		MessageBox(NULL, "Window initialization failed!\nExit.", "FATAL Error", MB_ICONERROR | MB_OK);
		return 0;
	}

	// obNobt@m
	{
		HDC hdc;
		BITMAPINFO bi = {0};

		hdc = GetDC(NULL);
		hBackBuffer = CreateCompatibleDC(hdc);
		ReleaseDC(NULL, hdc);

		bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bi.bmiHeader.biBitCount = 32;
		bi.bmiHeader.biPlanes = 1;
		bi.bmiHeader.biWidth = FIELDX;
		bi.bmiHeader.biHeight = FIELDY;
		if(!(hbold = SelectDIBSection(hBackBuffer, &bi, DIB_RGB_COLORS, NULL, NULL, 0)))
		{
			MessageBox(NULL, "CreateDIBSection failed!...\nExit.", "FATAL Error", MB_ICONERROR | MB_OK);
			return 0;
		}
		//FillRectangle(hBackBuffer, 0, 0, bi.bmiHeader.biWidth, bi.bmiHeader.biHeight, GetStockObject(BLACK_BRUSH));
	}

#ifdef USE_SOUND
	if(wmInitSystem())
	{
		MessageBox(NULL, "WaveOut initialize failed!\nExit.", "FATAL Error", MB_ICONERROR | MB_OK);
		return 0;
	}
	wavCube		= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_CUBE), "WAVE"))));
	wavDeath	= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_DEATH), "WAVE"))));
	wavGraboom	= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_GRABOOM), "WAVE"))));
	wavGrasel	= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_GRASEL), "WAVE"))));
	wavGrastart	= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_GRASTART), "WAVE"))));
	wavHit		= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_HIT), "WAVE"))));
	wavOver		= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_OVER), "WAVE"))));
	wavRestore	= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_RESTORE), "WAVE"))));
	wavScr		= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_SCR), "WAVE"))));
	wavShot		= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_SHOT), "WAVE"))));
	wavStart	= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_START), "WAVE"))));
	wavSwitch	= wmMemoryWave(LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDR_SWITCH), "WAVE"))));
#endif

#ifdef USE_MUSIC
	FSOUND_File_SetCallbacks(memopen, memclose, memread, memseek, memtell);
	cacheBGM();
#endif

	/*
	{
		// fix...
		DWORD i, j;

		for(i = 0; i < sizeof(vchar) / sizeof(struct _tag_vchar); i++)
		{
			for(j = 0; j < vchar[i].len; j++)
			{
				//LINE l = {(int)(vchar[i].pos[j].x1 * scale + x), (int)(vchar[i].pos[j].y1 * scale + y),
				//	(int)(vchar[i].pos[j].x2 * scale + x), (int)(vchar[i].pos[j].y2 * scale + y)};
				LINE* l = &vchar[i].pos[j];

				if(l->x1 == l->x2)
					if(l->y1 < l->y2)
						l->y2++;
					else
						l->y2--;
				if(l->y1 == l->y2)
					if(l->x1 < l->x2)
						l->x2++;
					else
						l->x2--;
			}
		}
	}
	*/

	tick = GetTickCount();
	fpstick = tick;
	fps = fpscounter = 0;
	replaying = FALSE;
	initGame();

	{
		HDC hdc = GetDC(NULL);

		if(GetDeviceCaps(hdc, HORZRES) <= 640 && GetDeviceCaps(hdc, VERTRES) <= 480)
		{
			if(changeScreenMode(TRUE))
				MessageBox(NULL, "Change screen mode failed", "Error", MB_ICONERROR | MB_OK);
		}else
		{
			if(changeScreenMode(FALSE))
				MessageBox(NULL, "Change screen mode failed", "Error", MB_ICONERROR | MB_OK);
		}
		ReleaseDC(NULL, hdc);
	}

	ShowCursor(FALSE);

	// DoEverything!!
	while(GetMessage(&msg, NULL, 0, 0))
		DispatchMessage(&msg);

	if(fullscreen)
		if(changeDisplayMode(FALSE))
			MessageBox(NULL, "Change screen mode failed", "Error", MB_ICONERROR | MB_OK);

	if(gamestatus == GAMESTAT_DIPSWITCH)	// stop the leak
		freeGUI();

#ifdef USE_MUSIC
	uncacheBGM();
#endif

#ifdef USE_SOUND
	wmUnloadWave(wavCube);
	wmUnloadWave(wavDeath);
	wmUnloadWave(wavGraboom);
	wmUnloadWave(wavGrasel);
	wmUnloadWave(wavGrastart);
	wmUnloadWave(wavHit);
	wmUnloadWave(wavOver);
	wmUnloadWave(wavRestore);
	wmUnloadWave(wavScr);
	wmUnloadWave(wavShot);
	wmUnloadWave(wavStart);
	wmUnloadWave(wavSwitch);

	wmUninitSystem();
#endif

	// ㏈
	RestoreObject(hBackBuffer, hbold);
	DeleteDC(hBackBuffer);

	return msg.wParam;
}
