// Rock's vertex degree dividing 360/ROCKDIVIDE=OneVertexDegree
#define ROCKDIVIDE 16
#define FIELDX 640
#define FIELDY 480
#define MAXROCKS 128
#define PI 3.14159

#define TIUNTIUNTIME 2500

#ifdef USE_MUSIC
// for minifmod
FMUSIC_MODULE* mod = NULL;

DWORD bgmtitlecount, bgmphase;
enum
{
	BGMPHASE_FADEIN,
	BGMPHASE_SHOWING,
	BGMPHASE_FADEOUT,
	BGMPHASE_END
};
#define BGMTC_FADE_TIME 60
#define BGMTC_SHOW_TIME 180

DWORD bgms[] = {
	IDR_MOD1,
	IDR_MOD2,
	IDR_MOD3,
	IDR_MOD4,
	IDR_MOD5,
	IDR_MOD6,
	IDR_MOD7,
	IDR_MOD8,
	IDR_MOD9,
	IDR_MOD10,
	IDR_MOD11,
	IDR_MOD12,
};
// bgms̕pӂ
FMUSIC_MODULE* mods[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,	//5
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,	//10
	NULL,
	NULL,
};
DWORD nowbgm = 0xFFFF;
#endif

#ifdef USE_SOUND
// for wavemix
PWAVEDATA wavCube, wavDeath, wavGraboom, wavGrasel, wavGrastart, wavHit, wavOver, wavRestore, wavScr, wavShot, wavStart, wavSwitch;
char* wavname[] = {
	"CUBE",
	"DEATH",
	"CUBERUSH BOOM",
	"SELECT TYPE",
	"CUBERUSH START",
	"HIT",
	"OVER",
	"RESTORE",
	"SCORE",
	"SHOT",
	"START",
	"SWITCH",
};
PWAVEDATA* wavdata[] = {
	&wavCube,
	&wavDeath,
	&wavGraboom,
	&wavGrasel,
	&wavGrastart,
	&wavHit,
	&wavOver,
	&wavRestore,
	&wavScr,
	&wavShot,
	&wavStart,
	&wavSwitch,
};
#endif

// in bytes
#define REPLAYBUFFERSIZE 1024
#define REPLAYVERSION 1

#define smaller(a, b) (((a) < (b)) ? (a) : (b))
#define bigger(a, b) (((a) > (b)) ? (a) : (b))
#define square(a) ((a)*(a))

HINSTANCE hInst;
HWND hMainWnd = NULL;
HDC hBackBuffer;
BOOL paused = FALSE;
int diecount;
DWORD elapsed;
DWORD score;
DWORD life;
int ships;
DWORD fps;
DWORD fpscounter, fpstick;
DWORD level;
DWORD tick, gametick, pregametick;
DWORD avoided;
DWORD levelupmsgcount;
BOOL cubecleared = FALSE;
BOOL startwavplaying;
BOOL fullscreen;

BOOL replaying;

// recording
enum
{
	RECORD_FRAMEEND,
	RECORD_MYSHIP,
	RECORD_MAKEROCK,
	RECORD_CLEARED,
};

enum
{
	GAMETYPE_NORMAL = 0,
	GAMETYPE_CUBERUSH,
	GAMETYPE_CUBERUSH2,
	GAMETYPE_CUBERUSH3,

	GAMETYPE_GTEOL,	// GameTypeEndOfList
};
BOOL gametype = GAMETYPE_NORMAL;

DWORD cubethrowed;
DWORD cubecount;

BOOL recordreplay = FALSE;
struct
{
	DWORD repversion;
	DWORD gametype;
	DWORD length;
	DWORD alloced;
	char* data;
}replaydata;

DWORD gamestatus;
enum
{
	GAMESTAT_TITLE,
	GAMESTAT_PLAYING,
	GAMESTAT_DEAD,
	GAMESTAT_GAMEOVER,
	GAMESTAT_CLEARED,

	GAMESTAT_DIPSWITCH,
};

POINT mcursor;

struct _tag_rock
{
	BOOL visible;
	float x;
	float y;
	int size;
	float px;
	float py;
	int vertex[ROCKDIVIDE];
	float rotate;
	float rotaterate;
	BOOL cubecounted;
}rock[MAXROCKS] = {0};
POINT myship;

typedef struct
{
	int x1;
	int y1;
	int x2;
	int y2;
}LINE;

struct
{
	DWORD recovertime;
	DWORD power;
	DWORD ships;
	DWORD leveluprate;
	DWORD extendscore;
	DWORD begindelay;
	DWORD startlevel;
	DWORD linewidth;
}config = 
{
	150,	// frames
	3,		// max hits
	3,		// ships
	1,		// x1
	10000,	// every 10000pts
	5000,	// meteo fall after 5000ms
	1,		// start from LEVEL.1
	1,		// LineWidth 1px
};

struct _tag_vchar
{
	char index;
	DWORD len;
	LINE pos[16];
}vchar[] = 
// 15x10 font
{
	// template
	{
		' ',
		1,
		0	,0	,0	,0	,
	},
	{
		'0',
		4,
		0	,0	,15	,0	,
		15	,0	,15	,20	,
		15	,20	,0	,20	,
		0	,20	,0	,0	,
	},
	{
		'1',
		1,
		15	,0	,15	,20	,
	},
	{
		'2',
		5,
		0	,0	,15	,0	,
		15	,0	,15	,10	,
		15	,10	,0	,10	,
		0	,10	,0	,20	,
		0	,20	,15	,20	,
	},
	{
		'3',
		4,
		0	,0	,15	,0	,
		15	,0	,15	,20	,
		15	,20	,0	,20	,
		0	,10	,15	,10	,
	},
	{
		'4',
		3,
		0	,0	,0	,10	,
		0	,10	,15	,10	,
		15	,0	,15	,20	,
	},
	{
		'5',
		5,
		0	,0	,15	,0	,
		0	,0	,0	,10	,
		15	,10	,0	,10	,
		15	,10	,15	,20	,
		0	,20	,15	,20	,
	},
	{
		'6',
		4,
		0	,0	,0	,20	,
		0	,10	,15	,10	,
		15	,10	,15	,20	,
		0	,20	,15	,20	,
	},
	{
		'7',
		2,
		0	,0	,15	,0	,
		15	,0	,15	,20	,
	},
	{
		'8',
		5,
		0	,0	,15	,0	,
		15	,0	,15	,20	,
		15	,20	,0	,20	,
		0	,20	,0	,0	,
		0	,10	,15	,10	,
	},
	{
		'9',
		4,
		0	,0	,15	,0	,
		0	,0	,0	,10	,
		0	,10	,15	,10	,
		15	,0	,15	,20	,
	},
	{
		'A',
		3,
		0	,20	,7	,0	,
		7	,0	,15	,20	,
		3	,10	,12	,10	,
	},
	{
		'B',
		8,
		0	,0	,0	,20	,
		0	,0	,10	,0	,
		10	,0	,15	,5	,
		15	,5	,10	,10	,
		10	,10	,0	,10	,
		10	,10	,15	,15	,
		15	,15	,10	,20	,
		0	,20	,10	,20	,
	},
	{
		'C',
		5,
		15	,0	,5	,0	,
		5	,0	,0	,5	,
		0	,5	,0	,15	,
		0	,15	,5	,20	,
		5	,20	,15	,20	,
	},
	{
		'D',
		6,
		0	,0	,10	,0	,
		10	,0	,15	,5	,
		15	,5	,15	,15	,
		15	,15	,10	,20	,
		0	,20	,10	,20	,
		0	,0	,0	,20	,
	},
	{
		'E',
		4,
		0	,0	,15	,0	,
		0	,0	,0	,20	,
		0	,20	,15	,20	,
		0	,10	,10	,10	,
	},
	{
		'F',
		3,
		0	,0	,15	,0	,
		0	,0	,0	,20	,
		0	,10	,10	,10	,
	},
	{
		'G',
		8,
		5	,0	,10	,0	,
		15	,10	,15	,15	,
		15	,15	,10	,20	,
		10	,20	,5	,20	,
		5	,20	,0	,15	,
		0	,15	,0	,5	,
		0	,5	,5	,0	,
		10	,10	,15	,10	,
	},
	{
		'H',
		3,
		0	,0	,0	,20	,
		15	,0	,15	,20	,
		0	,10	,15	,10	,
	},
	{
		'I',
		3,
		0	,0	,10	,0	,
		5	,0	,5	,20	,
		0	,20	,10	,20	,
	},
	{
		'J',
		5,
		10	,0	,15	,0	,
		13	,0	,13	,15	,
		13	,15	,8	,20	,
		5	,20	,8	,20	,
		0	,15	,5	,20	,
	},
	{
		'K',
		3,
		0	,0	,0	,20	,
		0	,15	,15	,0	,
		5	,10	,15	,20	,
	},
	{
		'L',
		2,
		0	,0	,0	,20	,
		0	,20	,15	,20	,
	},
	{
		'M',
		4,
		0	,0	,0	,20	,
		0	,0	,7	,7	,
		7	,7	,15	,0	,
		15	,0	,15	,20	,
	},
	{
		'N',
		3,
		0	,0	,0	,20	,
		0	,0	,15	,15	,
		15	,0	,15	,20	,
	},
	{
		'O',
		8,
		5	,0	,10	,0	,
		10	,0	,15	,5	,
		15	,5	,15	,15	,
		15	,15	,10	,20	,
		10	,20	,5	,20	,
		5	,20	,0	,15	,
		0	,15	,0	,5	,
		0	,5	,5	,0	,
	},
	{
		'P',
		5,
		0	,0	,0	,20	,
		0	,0	,10	,0	,
		10	,0	,15	,5	,
		15	,5	,10	,10	,
		10	,10	,0	,10	,
	},
	{
		'Q',
		9,
		5	,0	,10	,0	,
		10	,0	,15	,5	,
		15	,5	,15	,15	,
		15	,15	,10	,20	,
		10	,20	,5	,20	,
		5	,20	,0	,15	,
		0	,15	,0	,5	,
		0	,5	,5	,0	,
		10	,15	,15	,20	,
	},
	{
		'R',
		6,
		0	,0	,0	,20	,
		0	,0	,10	,0	,
		10	,0	,15	,5	,
		15	,5	,10	,10	,
		10	,10	,0	,10	,
		10	,10	,15	,20	,
	},
	{
		'S',
		9,
		15	,0	,5	,0	,
		5	,0	,0	,5	,
		0	,5	,5	,10	,
		5	,10	,10	,10	,
		10	,10	,15	,15	,
		15	,15	,10	,20	,
		10	,20	,0	,20	,

		15	,0	,15	,3	,
		0	,20	,0	,17	,
	},
	{
		'T',
		2,
		0	,0	,15	,0	,
		7	,0	,7	,20	,
	},
	{
		'U',
		5,
		15	,0	,15	,15	,
		15	,15	,10	,20	,
		10	,20	,5	,20	,
		5	,20	,0	,15	,
		0	,15	,0	,0	,
	},
	{
		'V',
		2,
		0	,0	,7	,20	,
		7	,20	,15	,0	,
	},
	{
		'W',
		4,
		0	,0	,0	,20	,
		0	,20	,7	,10	,
		7	,10	,15	,20	,
		15	,0	,15	,20	,
	},
	{
		'X',
		2,
		0	,0	,15	,20	,
		15	,0	,0	,20	,
	},
	{
		'Y',
		3,
		0	,0	,7	,10	,
		15	,0	,7	,10	,
		7	,10	,7	,20	,
	},
	{
		'Z',
		3,
		0	,0	,15	,0	,
		15	,0	,0	,20	,
		0	,20	,15	,20	,
	},
	{
		':',
		2,
		0	,5	,2	,5	,
		0	,15	,2	,15	,
	},
	{
		'.',
		1,
		0	,15	,0	,20	,
	},
	{
		',',
		1,
		5	,15	,0	,20	,
	},
	{
		'!',
		2,
		0	,0	,0	,13	,
		0	,19	,0	,20	,
	},
	{
		'%',
		3,
		15	,0	,0	,20	,
		0	,0	,0	,5	,
		15	,15	,15	,20	,
	},
	{
		']',
		3,
		0	,0	,5	,0	,
		5	,0	,5	,20	,
		0	,20	,5	,20	,
	},
	{
		'[',
		3,
		0	,0	,5	,0	,
		0	,0	,0	,20	,
		0	,20	,5	,20	,
	},
	{
		'+',
		2,
		0	,10	,10	,10	,
		5	,5	,5	,15	,
	},
	{
		'-',
		1,
		0	,10	,10	,10	,
	},
	{
		'&',
		6,
		0	,5	,15	,20	,
		0	,5	,5	,0	,
		5	,0	,10	,5	,
		10	,5	,0	,15	,
		0	,15	,5	,20	,
		5	,20	,15	,10	,
	},
	{
		'/',
		1,
		15	,0	,0	,20	,
	},
	{
		'|',
		1,
		0	,0	,0	,20	,
	},
	{
		'\x80',	// cursor
		4,
		0	,0	,10	,10	,	// "\"
		10	,10	,4	,10	,	// "-"
		4	,10	,0	,14	,	// "/"
		0	,0	,0	,14	,	// "|"
	}
};

// GUI
#define GUIOFFSETX 10
#define GUIOFFSETY 70
#define GUISCROLLBARSIZE 10
DWORD guiactive;
BOOL inputsequence;
enum{
	GUITYPE_LABEL,
	GUITYPE_BIGLABEL,
	GUITYPE_INPUT,
	GUITYPE_BUTTON,
	GUITYPE_LIST,
};
typedef struct _tag_gui
{
	RECT rc;
	DWORD type;
	char* text;
	DWORD val;
	DWORD scroll;
	int (*init)(struct _tag_gui*);
	int (*func)(struct _tag_gui*, POINT*);
	int (*free)(struct _tag_gui*);
	int (*wheel)(struct _tag_gui*, int);
} GUIITEM;

int guiDefListWheelProc(GUIITEM* g, int d)
{
	if(d < 0)	// Down
	{
		DWORD j;
		char* tx = g->text;

		for(j = 0; strlen(tx); j++)
			tx += strlen(tx) + 1;

		if(g->scroll < j - 1)
			g->scroll++;
	}else	// Top
	{
		if(0 < g->scroll)
			g->scroll--;
	}

	return 0;
}

int guiDefListProc(GUIITEM* g, POINT* p)
{
	if(g->rc.right - GUISCROLLBARSIZE < p->x)	// Scroll
	{
		guiDefListWheelProc(g, (g->rc.bottom / 2 < p->y) ? -1 : 1);

		return 1;
	}else	// Select
	{
		DWORD j;
		char* tx = g->text;
		DWORD s;

		for(j = 0; strlen(tx); j++)
			tx += strlen(tx) + 1;

		s = (p->y - 1) / 15 + g->scroll;
		if(s < j)
		{
			g->val = s;
			return 0;
		}else
			return 1;
	}
}
#ifdef USE_MUSIC
void changeBGM(DWORD);
int guifuncStopMusic(GUIITEM* g, POINT* p)
{
	changeBGM(0xFFFF);

	return 0;
}
int guifuncPlayMusic(GUIITEM* g, POINT* p)
{
	if(guiDefListProc(g, p))
		return 0;

	changeBGM(bgms[g->val]);

	return 0;
}
int guifuncInitMusic(GUIITEM* g)
{
	DWORD j;
	DWORD l;

	g->text = malloc(1);
	*g->text = '\0';
	l = 1;

	for(j = 0; j < sizeof(mods) / sizeof(FMUSIC_MODULE*); j++)
	{
		char tmp[80];
		DWORD p = l - 1;

		strcpy(tmp, FMUSIC_GetTitle(mods[j]));
		strupr(tmp);

		l += strlen(tmp) + 1;
		g->text = realloc(g->text, l);
		strcpy(g->text + p, tmp);
	}
	*(g->text + l - 1) = '\0';

	g->val = nowbgm;

	return 0;
}
int guifuncFreeMusic(GUIITEM* g)
{
	if(g->text)
	{
		free(g->text);
		g->text = NULL;
	}

	return 0;
}
#endif
#ifdef USE_SOUND
int guifuncStopSound(GUIITEM* g, POINT* p)
{
	wmKillAllWave();

	return 0;
}
int guifuncPlaySound(GUIITEM* g, POINT* p)
{
	if(guiDefListProc(g, p))
		return 0;

	wmPlayWave(*wavdata[g->val]);

	return 0;
}
int guifuncInitSound(GUIITEM* g)
{
	DWORD j;
	DWORD l;

	g->text = malloc(1);
	*g->text = '\0';
	l = 1;

	for(j = 0; j < sizeof(wavname) / sizeof(char*); j++)
	{
		DWORD p = l - 1;

		l += strlen(wavname[j]) + 1;
		g->text = realloc(g->text, l);
		strcpy(g->text + p, wavname[j]);
	}
	*(g->text + l - 1) = '\0';

	return 0;
}
int guifuncFreeSound(GUIITEM* g)
{
	if(g->text)
	{
		free(g->text);
		g->text = NULL;
	}

	return 0;
}
#endif

GUIITEM gui[] = {
	// Power
	{
		0, 0, 100, 15,
		GUITYPE_LABEL,
		"POWER",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
	{
		100, 0, 100, 15,
		GUITYPE_INPUT,
		(char*)&config.power,
		0,
		0,
		NULL, NULL, NULL, NULL,
	},

	// Ships
	{
		0, 20, 100, 15,
		GUITYPE_LABEL,
		"SHIPS",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
	{
		100, 20, 100, 15,
		GUITYPE_INPUT,
		(char*)&config.ships,
		0,
		0,
		NULL, NULL, NULL, NULL,
	},

	// RecoverTime
	{
		0, 45, 100, 15,
		GUITYPE_LABEL,
		"RECOVER",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
	{
		0, 60, 100, 15,
		GUITYPE_LABEL,
		"TIME",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
	{
		100, 60, 100, 15,
		GUITYPE_INPUT,
		(char*)&config.recovertime,
		0,
		0,
		NULL, NULL, NULL, NULL,
	},

	// BeginDelay
	{
		0, 80, 100, 15,
		GUITYPE_LABEL,
		"DELAY",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
	{
		100, 80, 100, 15,
		GUITYPE_INPUT,
		(char*)&config.begindelay,
		0,
		0,
		NULL, NULL, NULL, NULL,
	},

	// StartLevel
	{
		0, 100, 100, 15,
		GUITYPE_LABEL,
		"LEVEL",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
	{
		100, 100, 100, 15,
		GUITYPE_INPUT,
		(char*)&config.startlevel,
		0,
		0,
		NULL, NULL, NULL, NULL,
	},

	// LineWidth
	{
		0, 120, 100, 15,
		GUITYPE_LABEL,
		"LINE",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
	{
		100, 120, 100, 15,
		GUITYPE_INPUT,
		(char*)&config.linewidth,
		0,
		0,
		NULL, NULL, NULL, NULL,
	},

	{
		300, 0, 300, 15,
		GUITYPE_LABEL,
		"SONG TEST",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
#ifdef USE_MUSIC
	{
		500, 0, 100, 15,
		GUITYPE_BUTTON,
		"STOP",
		0,
		0,
		NULL, guifuncStopMusic, NULL, NULL,
	},
	{
		300, 15, 300, 100,
		GUITYPE_LIST,
		NULL,
		0,
		0,
		guifuncInitMusic, guifuncPlayMusic, guifuncFreeMusic, guiDefListWheelProc,
	},
#else
	{
		300, 15, 300, 100,
		GUITYPE_LIST,
		"SONG N/A\0",
		0,
		0,
		NULL, guiDefListProc, NULL, NULL,
	},
#endif

	{
		300, 120, 200, 15,
		GUITYPE_LABEL,
		"SOUND TEST",
		0,
		0,
		NULL, NULL, NULL, NULL,
	},
#ifdef USE_SOUND
	{
		500, 120, 100, 15,
		GUITYPE_BUTTON,
		"STOP",
		0,
		0,
		NULL, guifuncStopSound, NULL, NULL,
	},
	{
		300, 120 + 15, 300, 100,
		GUITYPE_LIST,
		NULL,
		0,
		0,
		guifuncInitSound, guifuncPlaySound, guifuncFreeSound, guiDefListWheelProc,
	},
#else
	{
		300, 120 + 15, 300, 100,
		GUITYPE_LIST,
		"SOUND N/A\0",
		0,
		0,
		NULL, guiDefListProc, NULL, NULL,
	},
#endif
};
